
local Semi_Color_Table = {
"|cff9d9d9d",
"|cffffffff",
"|cff1eff00",
"|cff0070dd",
"|cffa335ee",
"|cffff8000",
"|cffe6cc80",
"|cffe6cc80"
}

function Semi_ASR_SlashHandler(msg, editbox)
    local command, rest = msg:match("^(%S*)%s*(.-)$");
	command = string.lower(command);
	if (command == "chat") then
		S_ASR_ToggleChat();
	elseif (command == "repair") then
		S_ASR_ToggleRepairs();
    elseif (command == "guild") then
        S_ASR_ToggleGuild();
    elseif (command == "add") then
        S_ASR_AddException(rest);
	elseif (command == "addc") then
		S_ASR_Add_Character_Exception(rest);
    elseif (command == "remove") then
		S_ASR_RemoveException(rest);
	elseif (command == "removec") then
		S_ASR_Remove_Character_Exception(rest);
	elseif (command == "?") then
		S_ASR_isItemInExceptionList(rest);
    elseif (command == "options") or (command == "option") then
		InterfaceOptionsFrame_OpenToCategory("Semi's ASR");
	elseif (command == "status") then
		S_ASR_Status();
	elseif (command == "list") then
		S_ASR_ListExceptions();
	else
		print("|cffff0000/asr |cff00ccffstatus |cffffffff- Display status of current settings to Chat Frame.");
		print("|cffff0000/asr |cff00ccffoption(s) |cffffffff- opens Options Panel");
		print("|cffff0000/asr |cff00ccffadd |cFF008000{item link} |cffffffff- [ACCOUNT-WIDE] - Adds a grey item to the Do Not Sell list OR adds non-grey items to the Sell list.");
		print("|cffff0000/asr |cff00ccffaddC |cFF008000{item link} |cffffffff- [Character] - Adds a grey item to the Do Not Sell list OR adds non-grey items to the Sell list.");
		print("|cffff0000/asr |cff00ccffremove |cFF008000{item link} |cffffffff- [ACCOUNT-WIDE] - Removes a grey item from the Do Not Sell list OR removes non-grey items from the Sell List.");
		print("|cffff0000/asr |cff00ccffremoveC |cFF008000{item link} |cffffffff- [Character] - Removes a grey item from the Do Not Sell list OR removes non-grey items from the Sell List.");
		--print("|cffff0000/asr |cff00ccff? |cFF008000{item link} |cffffffff- Queries the list to see if the item will be auto sold.");
	end    
end


function Semi_ASR_OnEvent(self, event, ...)
    if (event == "MERCHANT_SHOW") then
		S_ASR_MerchantShow();
    end
    if (event == "ADDON_LOADED") and (string.lower(select(1, ...)) == "semi_asr") then
		SlashCmdList["SEMI_ASRCOMMAND"] = Semi_ASR_SlashHandler;
		SLASH_SEMI_ASRCOMMAND1 = "/asr";
		
		print("|cffff0000Semi's Auto Seller & Repairer |cff00ccffLoaded!!!");
        print("Type |cffff0000/asr|cffffffff for options.");
		if S_ASR_ShowChatText == nil then
			S_ASR_ShowChatText = true;
		end
		if S_ASR_UseGuildRepair == nil then
			S_ASR_UseGuildRepair = false;
		end
		if S_ASR_AutoRepairs == nil then
			S_ASR_AutoRepairs = false;
		end
		if S_ASR_Global_ExceptionList == nil then
			S_ASR_Global_ExceptionList = {};
		end
		if S_ASR_Local_ExceptionList == nil then
			S_ASR_Local_ExceptionList = {};
		end
    end
end

function S_ASR_MerchantShow()
	-- Sells junk and repairs gear
    S_ASR_SellJunk();
    if CanMerchantRepair() and S_ASR_AutoRepairs then
		S_ASR_Repair();			
    end
end

function S_ASR_SellJunk()
 	--Sells all grey items in bags that are not on the Exception List to keep.
	--Sells above grey quality level items in the Exception List, these are items added by the user
	local bagnum, bagslots, slotnum, gold, newgold, goldmade, link;
	gold = 0;
	slotnum = 0;
	for bagnum = 0, 4 do 
	    bagslots = GetContainerNumSlots(bagnum);
	    if bagslots > 0 then
	        for slotnum = 1, bagslots do
	          link = GetContainerItemLink(bagnum, slotnum);
			  if link ~= nil then
				--local itemName = select(1,GetItemInfo(link));
				local itemId = select(3,strfind(link, "^|%x+|Hitem:(%-?%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%-?%d+):(%-?%d+)"));
				local itemCount = select(2, GetContainerItemInfo(bagnum, slotnum));
				local itemRarity = select(3, GetItemInfo(link));
				if (itemRarity ~= 0) then
					if (S_ASR_Global_ExceptionList[itemId]) then
						gold = gold + (select(11,GetItemInfo(link))*itemCount);
						UseContainerItem(bagnum, slotnum);
					elseif (S_ASR_Local_ExceptionList[itemId]) then
							gold = gold + (select(11,GetItemInfo(link))*itemCount);
							UseContainerItem(bagnum, slotnum);
					end
				elseif (not S_ASR_Global_ExceptionList[itemId]) and (not S_ASR_Local_ExceptionList[itemId]) then
	                    gold = gold + (select(11,GetItemInfo(link))*itemCount);
	                    UseContainerItem(bagnum, slotnum);
				end		    
			  end
	        end
	    end
	end
    if S_ASR_ShowChatText and (gold ~= 0) then
    	print("Earned: ".. GetCoinTextureString(gold) .. " from selling junk.");
    end
end

function S_ASR_Repair()
    local cost, needRepair = GetRepairAllCost();
    local gold = GetMoney();
    local guildGold = GetGuildBankWithdrawMoney();
    local canRepair = CanGuildBankRepair();
	if S_ASR_AutoRepairs then
		if S_ASR_UseGuildRepair and canRepair and needRepair and ((cost <= guildGold) or (guildGold == -1)) then
			RepairAllItems(canRepair);
			if(S_ASR_ShowChatText) then
				print("Repaired for: ".. GetCoinTextureString(cost).." using |cff00ccffGuild |cfffffffffunds.");
			end
		elseif (needRepair and cost <= gold) then
			RepairAllItems();
			if(S_ASR_ShowChatText) then
				print("Repaired for: ".. GetCoinTextureString(cost).." using |cff00ccffYour |cfffffffffunds.");
			end
		elseif (needRepair and cost > gold) then
			print("You are poor! Borrow some money to make repairs.");	
		elseif S_ASR_ShowChatText then
			print("|cff00ccffDurability 100% |cffffffff- |cffff0000Repairs not needed.");
		end  
	end
end


function S_ASR_ToggleChat()
    if S_ASR_ShowChatText then
	    S_ASR_ShowChatText = false
	    print("|cff00ccffChat text |cffffffffturned |cffff0000OFF.");
    else
	    S_ASR_ShowChatText = true
	    print("|cff00ccffChat text |cffffffffturned |cffff0000ON.");
    end
	Semi_ASR_Config_FrameCheckButtonChat:SetChecked(S_ASR_ShowChatText);
end

function S_ASR_ToggleRepairs()
	if S_ASR_AutoRepairs then
		S_ASR_AutoRepairs = false;
		print("|cff00ccffAutomatic Repairs |cffffffffturned |cffff0000OFF.");
	else
		S_ASR_AutoRepairs = true;
		print("|cff00ccffAutomatic Repairs |cffffffffturned |cffff0000ON.");
	end
	Semi_ASR_Config_FrameCheckButtonAutoRepairs:SetChecked(S_ASR_AutoRepairs);
end

function S_ASR_ToggleGuild()
    if S_ASR_UseGuildRepair then
	    S_ASR_UseGuildRepair = false;
	    print("|cff00ccffGuild Funds |cfffffffffor |cff00ccffRepairs |cffffffffturned |cffff0000OFF.");
    else
	    S_ASR_UseGuildRepair = true;
	    print("|cff00ccffGuild Funds |cfffffffffor |cff00ccffRepairs |cffffffffturned |cffff0000ON.");
   end
   Semi_ASR_Config_FrameCheckButtonGuild:SetChecked(S_ASR_UseGuildRepair);
end

function S_ASR_Status()
	if S_ASR_ShowChatText then
		print("|cff00ccffChat text |cffffffffis |cffff0000ON.");
	elseif (not S_ASR_ShowChatText) then
		print("|cff00ccffChat text |cffffffffis |cffff0000OFF.");
	end
	if S_ASR_AutoRepairs then
		print("|cff00ccffAutomatic Repairs |cffffffffare |cffff0000ON.");
	elseif (not S_ASR_AutoRepairs) then
		print("|cff00ccffAutomatic Repairs |cffffffffare |cffff0000OFF.");
	end
	if S_ASR_UseGuildRepair then
		print("|cff00ccffGuild Funds for Repairs |cffffffffare |cffff0000ON.");
	elseif (not S_ASR_UseGuildRepair) then
		print("|cff00ccffGuild Funds for Repairs |cffffffffare |cffff0000OFF.");
	end
end

function S_ASR_ListExceptions()
	local S_ASR_ListCount = 0;
	for k,v in pairs(S_ASR_Global_ExceptionList) do
		S_ASR_ListCount = S_ASR_ListCount + 1
	end
	if S_ASR_ListCount > 0 then
		local S_ASR_ListIndex = 1;
		local itemName, itemRarity;
		print("|cffff0000ASR |cff00ccffGlobal |cffffffffExceptions: |cff00ccff"..S_ASR_ListCount);
		for k,v in pairs(S_ASR_Global_ExceptionList) do
			itemName, itemRarity = strsplit(":", v);
			itemRarity = tonumber(itemRarity);
			print("["..S_ASR_ListIndex.."]",Semi_Color_Table[itemRarity+1],itemName);
			S_ASR_ListIndex = S_ASR_ListIndex + 1
		end
	end
	if S_ASR_ListCount == 0 then
		print("No Items are in the Global Exception List.");
	end
	S_ASR_ListCount = 0;
	for k,v in pairs(S_ASR_Local_ExceptionList) do
		S_ASR_ListCount = S_ASR_ListCount + 1
	end
	if S_ASR_ListCount > 0 then
		local S_ASR_ListIndex = 1;
		local itemName, itemRarity;
		print("|cffff0000ASR |cff00ccffCharacter |cffffffffExceptions: |cff00ccff"..S_ASR_ListCount);
		for k,v in pairs(S_ASR_Local_ExceptionList) do
			itemName, itemRarity = strsplit(":", v);
			itemRarity = tonumber(itemRarity);
			print("["..S_ASR_ListIndex.."]",Semi_Color_Table[itemRarity+1],itemName);
			S_ASR_ListIndex = S_ASR_ListIndex + 1
		end
	end
	if S_ASR_ListCount == 0 then
		print("No Items are in this Character's Exception List.");
	end
end

function S_ASR_AddException(link)
	-- add an item to the global(account-wide) exception list
    if link then
		local itemName = select(1,GetItemInfo(link));
		local itemId = select(3,strfind(link, "^|%x+|Hitem:(%-?%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%-?%d+):(%-?%d+)"));
		local itemRarity = select(3, GetItemInfo(link));
		if itemRarity == 0 then
			if S_ASR_Global_ExceptionList[itemId] then
				print(link .. " is already on the Account-Wide do not sell list.")
			else
				S_ASR_Global_ExceptionList[itemId] = strjoin(":", itemName, itemRarity);
				print(link .. " has been added to the Account-Wide do not sell list.")
			end
		else
			if S_ASR_Global_ExceptionList[itemId] then
				print(link.. " is already on the Account-Wide sell list.");
			else
				S_ASR_Global_ExceptionList[itemId] = strjoin(":", itemName, itemRarity);
				print(link.. " has been added to the Account-Wide sell list.");
			end
		end
    end
end

function S_ASR_Add_Character_Exception(link)
	-- add an item to the local(character) exception list
    if link then
		local itemName = select(1,GetItemInfo(link));
		local itemId = select(3,strfind(link, "^|%x+|Hitem:(%-?%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%-?%d+):(%-?%d+)"));
		local itemRarity = select(3, GetItemInfo(link));
		if itemRarity == 0 then
			if S_ASR_Local_ExceptionList[itemId] then
				print(link .. " is already on this Character's do not sell list.")
			else
				S_ASR_Local_ExceptionList[itemId] = strjoin(":", itemName, itemRarity);
				print(link .. " has been added to this Character's do not sell list.")
			end
		else
			if S_ASR_Local_ExceptionList[itemId] then
				print(link.. " is already on this Character's sell list.");
			else
				S_ASR_Local_ExceptionList[itemId] = strjoin(":", itemName, itemRarity);
				print(link.. " has been added to this Character's sell list.");
			end
		end
    end
end

function S_ASR_RemoveException(link)
	--Remove an item from the global(account-wide) exception list
    if link then
		local itemName = select(1,GetItemInfo(link));
		local itemId = select(3,strfind(link, "^|%x+|Hitem:(%-?%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%-?%d+):(%-?%d+)"));
		local itemRarity = select(3, GetItemInfo(link));
		if itemRarity == 0 then
			if S_ASR_Global_ExceptionList[itemId] then
				S_ASR_Global_ExceptionList[itemId] = nil;
				print(link .. " has been removed from the Account-Wide do not sell list.");
			else
				print(link .. " is not on the Account-Wide do not sell list.");
			end
		else
			if S_ASR_Global_ExceptionList[itemId] then
				S_ASR_Global_ExceptionList[itemId] = nil;
				print(link.. " has been removed from the Account-Wide sell list.");
			else
				print(link.. " is not on the Account-Wide sell list.");
			end
		end 
    end
end

function S_ASR_Remove_Character_Exception(link)
	--Remove an item from the local(character) exception list
    if link then
		local itemName = select(1,GetItemInfo(link));
		local itemId = select(3,strfind(link, "^|%x+|Hitem:(%-?%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%-?%d+):(%-?%d+)"));
		local itemRarity = select(3, GetItemInfo(link));
		if itemRarity == 0 then
			if S_ASR_Local_ExceptionList[itemId] then
				S_ASR_Local_ExceptionList[itemId] = nil;
				print(link .. " has been removed from this Character's do not sell list.");
			else
				print(link .. " is not on this Character's do not sell list.");
			end
		else
			if S_ASR_Local_ExceptionList[itemId] then
				S_ASR_Local_ExceptionList[itemId] = nil;
				print(link.. " has been removed from this Character's sell list.");
			else
				print(link.. " is not on this Character's sell list.");
			end
		end 
    end
end

function S_ASR_isItemInExceptionList(link)
	if link then
		local itemId = select(3,strfind(link, "^|%x+|Hitem:(%-?%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%-?%d+):(%-?%d+)"));
		local itemRarity = select(3, GetItemInfo(link));
		if itemRarity == 0 then
			if S_ASR_Global_ExceptionList[itemId] then
				print(link .. " is Account-Wide protected and |cffff0000will not be |cffffffffauto |cffff0000sold.");
			elseif S_ASR_Local_ExceptionList[itemId] then
				print(link.. " is Character protected and |cffff0000will not be |cffffffffauto |cffff0000sold.");
			else
				print(link .. " is Junk and will be sold with all grey items.");
			end
		else
			if S_ASR_Global_ExceptionList[itemId] then
				print(link.. " |cffff0000will be |cffffffffauto |cffff0000sold |cffffffffAccount-Wide.");
			elseif S_ASR_Local_ExceptionList[itemId] then
				print(link.." |cffff0000will be |cffffffffauto |cffff0000sold |cffffffffon this Character.");
			else
				print(link.. " is not on the auto sale list.");
			end
		end 
    end
end

function S_ASR_Config_OnLoad(self)
	panel = Semi_ASR_Config_Frame;	
	panel.name = "Semi's ASR";
	if IsAddOnLoaded("Semi_Core") then
		panel.parent = "Semi";
	end
	Semi_ASR_Config_FrameTitle:SetText("|cff00ccffSemi|cffffffff's |cffff0000A|cffffffffuto |cffff0000S|cffffffffeller |cff00ccff& |cffff0000R|cffffffffepairer");
        InterfaceOptions_AddCategory(panel);
end

function S_ASR_Config_OnShow(self)
	_G[self:GetName().."CheckButtonChat"]:SetChecked(S_ASR_ShowChatText);
	_G[self:GetName().."CheckButtonGuild"]:SetChecked(S_ASR_UseGuildRepair);
	_G[self:GetName().."CheckButtonAutoRepairs"]:SetChecked(S_ASR_AutoRepairs);
end

function S_ASR_ConfigOption_OnClick(self)

	if (self:GetName() == (self:GetParent():GetName().."CheckButtonChat" ) ) then
		S_ASR_ToggleChat();
	elseif (self:GetName() == (self:GetParent():GetName().."CheckButtonGuild" ) ) then
		S_ASR_ToggleGuild();
	elseif (self:GetName() == (self:GetParent():GetName().."CheckButtonAutoRepairs")) then
		S_ASR_ToggleRepairs();
	end
end